#ifndef LIBWIDGET_H
#define LIBWIDGET_H

#include <QWidget>

namespace Ui {
    class LibWidget;
}

#include "team.h"
#include "map.h"

class LibWidget : public QWidget
{
    Q_OBJECT

public:
    explicit LibWidget(QWidget *parent = 0);
    ~LibWidget();

private slots:
    void refreshBehaviors();
    void refreshGenerators();
    void launchSimulation();

private:
    Ui::LibWidget *ui;
    std::vector<GenerateFunction> m_genList;
    std::vector<BehaviorFunction> m_behaviorList;

signals:
    void sendError(QString, int);
    void createSimulation(GenerateFunction, std::vector<BehaviorFunction>);
};

#endif // LIBWIDGET_H
