#ifndef BEHAVIOR_H
#define BEHAVIOR_H

#include "coord.h"

#define DUDE_MEMORY_SIZE 128
#define LIBRARY_SIZE 128
#define COM_SIZE 32

struct Com
{
    enum Flags {
        BOOK1 = 0,
        BOOK2 = 1,
        BOOK3 = 2,
        BOOK4 = 3,
        
        READ  = 0,
        WRITE = 4
    };

	int flag;
	char data[COM_SIZE];
};

struct Action
{
    enum Type {
        MOVE,
        ATTACK,
        PICK,
        PUT,
        WORK,
        WAIT,
        COLOR,
        COMMUNICATE
    };
    
	Type type;
	Dir dir;
	Com com_data;
};

class Info
{
    // TODO
public:
    bool success;
    int inventory;
    const Com& getCom();
    int getNear(Dir d);
    int getInfo(Dir d);
};

typedef void (*BehaviorFunction)(Action *action, char *memory, const Info *info);

#endif // BEHAVIOR_H
